﻿using System;
using System.Collections.Generic;
using System.Configuration.Install;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.ServiceProcess;
using System.Text;
using System.Threading.Tasks;

namespace Test
{
    class Program
    {
        public static string ServiceName { get; set; }
        private static ServiceBase sb;

        static Program()
        {
            sb = new MainService();
            ServiceName = sb.ServiceName;
        }

        static void Main(string[] args)
        {
            if (args != null && args.Length > 0)
            {
                ServerStart();
            }
            else
            {
                while (true)
                {
                    Console.WriteLine("1.安装 2.启动 3.停止 4.卸载");
                    AppStart();
                }
            }
        }

        private static void ServerStart()
        {
            ServiceBase.Run(sb);
        }

        private static void AppStart()
        {
            try
            {
                int num = int.Parse(Console.ReadLine());
                switch (num)
                {
                    case 1:
                        Setup();
                        break;
                    case 2:
                        Run();
                        break;
                    case 3:
                        Stop();
                        break;
                    case 4:
                        Unload();
                        break;
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
        }

        private static void Unload()
        {
            Process.Start("sc", "delete " + ServiceName);
        }

        private static void Stop()
        {
            var sc = new ServiceController(ServiceName);
            sc.Stop();
        }

        private static void Run()
        {
            var sc = new ServiceController(ServiceName);
            sc.Start(new[] { "s" });
        }

        private static void Setup()
        {
            var filePath = Process.GetCurrentProcess().MainModule.FileName + " s";
            var cmd = "create MainService binpath= \"" + filePath + "\"";
            Process.Start("sc", cmd);
        }
    }
}
